﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Data.SqlClient
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Math
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_20_Blaettern

Public Class Cls_03_DB_Person_Delete

    REM **************************************************************
    REM *  Löschfunktion für Person + Subsätze                       *
    REM **************************************************************
    Public Shared Sub Person_Delete()

        Dim str_MsgZeileG As String
        Dim str_MsgZeile1 As String
        Dim str_MsgZeile2 As String
        Dim str_MsgZeile3 As String
        Dim str_MsgZeile4 As String
        Dim str_MsgZeile5 As String
        Dim str_MsgZeile6 As String

        Dim int_Del_Rolle3 As Integer
        Dim int_Del_Rolle5 As Integer
        Dim int_Del_Rolle6 As Integer
        Dim int_Del_Rolle7 As Integer
        Dim int_Del_Rolle8 As Integer
        Dim int_Del_Rolle9 As Integer
        Dim int_Del_Paten As Integer
        Dim int_Del_Zeuge As Integer
        Dim int_Del_Ehen As Integer
        Dim int_Del_Komm As Integer
        Dim int_Del_Pic As Integer

        REM *--------------------------------------------------------*
        REM *  Alle Verbindungen ermitteln                           *
        REM *  - Rollenfunktionen                                    *
        REM *  - Elternverweis                                       *
        REM *  - Ehen                                                *
        REM *  - Kommentare                                          *
        REM *  - Bilder                                              *
        REM *--------------------------------------------------------*
        mySelect.CommandText = "select count(*) from t05_Rolle"

        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 5"
        int_Del_Rolle5 = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 6"
        int_Del_Rolle6 = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 7"
        int_Del_Rolle7 = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 8"
        int_Del_Rolle8 = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 9"
        int_Del_Rolle9 = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)
        int_Del_Paten = int_Del_Rolle5 + int_Del_Rolle6
        int_Del_Zeuge = int_Del_Rolle7 + int_Del_Rolle8 + int_Del_Rolle9

        str_Where = " where t05_FK_t01 = " + p_int_ID.ToString + " and t05_Typ = 3"
        int_Del_Rolle3 = GetNumberOfRecordsTyp(con, "t05_Rolle", str_Where)

        str_Where = " where t04_Partner1 = " + p_int_ID.ToString
        int_Del_Ehen = GetNumberOfRecordsTyp(con, "t04_Ehe", str_Where)

        str_Where = " where t11_FK_t01 = " + p_int_ID.ToString
        int_Del_Komm = GetNumberOfRecordsTyp(con, "t11_Kommentar", str_Where)

        str_Where = " where t09_FK_t01 = " + p_int_ID.ToString
        int_Del_Pic = GetNumberOfRecordsTyp(con, "t09_Bild", str_Where)

        str_MsgZeile1 = "Person = " + p_str_Name + ", " + p_str_Vorname & vbCrLf
        str_MsgZeile2 = " - Anzahl Paten: " + int_Del_Paten.ToString & vbCrLf
        str_MsgZeile3 = " - Anzahl Zeugen: " + int_Del_Zeuge.ToString & vbCrLf
        str_MsgZeile4 = " - Elternverweis: " + int_Del_Rolle3.ToString & vbCrLf
        str_MsgZeile5 = " - Kommentare: " + int_Del_Komm.ToString & vbCrLf
        str_MsgZeile6 = " - Bilder: " + int_Del_Pic.ToString & vbCrLf

        str_MsgZeileG = str_MsgZeile1 + str_MsgZeile2 + str_MsgZeile3 + str_MsgZeile4 + str_MsgZeile5 + str_MsgZeile6

        REM *--------------------------------------------------------*
        REM *  Sicherheitsabfrage                                    *
        REM *--------------------------------------------------------*
        Dim str_Msg As String = "Soll der Datensatz wirklich gelöscht werden? "
        Dim result As DialogResult = MessageBox.Show(str_MsgZeileG, str_Msg, MessageBoxButtons.OKCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)

        REM *--------------------------------------------------------*
        REM * Keine Löschung                                         *
        REM *--------------------------------------------------------*
        If result = DialogResult.No Then
            Exit Sub
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Paten                *
        REM *--------------------------------------------------------*
        If int_Del_Paten > 0 Then
            Call Person_Del_Paten()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Zeugen               *
        REM *--------------------------------------------------------*
        If int_Del_Zeuge > 0 Then
            Call Person_Del_Zeugen()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Elternverweis        *
        REM *--------------------------------------------------------*
        If int_Del_Rolle3 > 0 Then
            Call Person_Del_Eltern()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Kommentare           *
        REM *--------------------------------------------------------*
        If int_Del_Komm > 0 Then
            Call Person_Del_Kommentar()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Bilder               *
        REM *--------------------------------------------------------*
        If int_Del_Pic > 0 Then
            Call Person_Del_Bilder()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Adressen             *
        REM *--------------------------------------------------------*
        If int_Merk_Tab_Anschr > 0 Then
            Call Person_Del_Adresse()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Berufe               *
        REM *--------------------------------------------------------*
        If int_Merk_Tab_Beruf > 0 Then
            Call Person_Del_Beruf()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Text                 *
        REM *--------------------------------------------------------*
        If int_Merk_Tab_Text > 0 Then
            Call Person_Del_Text()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Beerdigung           *
        REM *--------------------------------------------------------*
        If int_Merk_Tab_Beerd > 0 Then
            Call Person_Del_Beerd()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Taufe                *
        REM *--------------------------------------------------------*
        If int_Merk_Tab_Taufe > 0 Then
            Call Person_Del_Taufe()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Ehe                  *
        REM *--------------------------------------------------------*
        If int_Merk_Tab_Ehe > 0 Then
            Call Person_Del_Ehe()
        End If

        REM *--------------------------------------------------------*
        REM *  Datensatz soll gelöscht werden - Person               *
        REM *--------------------------------------------------------*
        Call Person_Del_Basis()

        REM *--------------------------------------------------------*
        REM *  Datensatz 1 lesen und anzeigen                        *
        REM *--------------------------------------------------------*
        Call ID_Tab_Fuell()
        Call Blaettern_First()

    End Sub


    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Paten()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t05_Rolle where t05_FK_t01 = " & p_int_ID.ToString + " and t05_Typ = 5"
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t05_Rolle where t05_FK_t01 = " & p_int_ID.ToString + " and t05_Typ = 6"
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Zeugen()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t05_Rolle where t05_FK_t01 = " & p_int_ID.ToString + " and t05_Typ = 7"
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t05_Rolle where t05_FK_t01 = " & p_int_ID.ToString + " and t05_Typ = 8"
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t05_Rolle where t05_FK_t01 = " & p_int_ID.ToString + " and t05_Typ = 9"
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Eltern()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t05_Rolle where t05_FK_t01 = " & p_int_ID.ToString + " and t05_Typ = 3"
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub


    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Kommentar()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t10_KommNr where t10_ID = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t11_Kommentar where t11_FK_t01 = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub


    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Bilder()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t09_Bild where t09_FK_t01 = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Text()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t12_Text where t12_ID = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Beruf()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t07_Beruf where t07_FK_t01 = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Adresse()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t06_Adr where t06_FK_t01 = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub


    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Beerd()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t03_Beerd where t03_ID = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Taufe()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t02_Taufe where t02_ID = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try


    End Sub

    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Ehe()

        Dim reader As OleDbDataReader
        mySelect.Connection = con

        For int_l01 = 0 To int_Ehe
            p_int_Ehe = lng_Ehe_ID(int_l01)
            str_Where = " where t04_Partner1 = " + p_int_ID.ToString + " and t04_Partner2 = " + p_int_Ehe.ToString
            mySelect.CommandText = "select * from t04_Ehe + str_Where"

            Try
                reader = mySelect.ExecuteReader
                Do While reader.Read
                    dbl_Ehe41 = reader.Item("t04_FK_ID")
                Loop
                reader.Close()
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try

            mySelect.Connection = con
            mySelect.CommandText = "delete * from t041_EheDaten where t041_ID = " & dbl_Ehe41.ToString
            Try
                DB_Anz = mySelect.ExecuteNonQuery
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try

        Next

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t04_Ehe where t04_Partner1 = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        mySelect.Connection = con
        mySelect.CommandText = "delete * from t04_Ehe where t04_Partner2 = " & p_int_Ehe.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try


    End Sub


    REM **************************************************************
    REM *  Datensatz löschen                                         *
    REM **************************************************************
    Public Shared Sub Person_Del_Basis()

        mySelect.Connection = con
        mySelect.CommandText = "delete * from t01_Person where t01_ID = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        REM *---------------------------------------------------------*
        REM *  Datensatz in Tabelle KommNr löschen                    *
        REM *---------------------------------------------------------*
        mySelect.Connection = con
        mySelect.CommandText = "delete * from t10_KomNr where t10_ID = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        REM *---------------------------------------------------------*
        REM *  Datensatz in Search-Tabelle löschen                    *
        REM *---------------------------------------------------------*
        mySelect.Connection = con
        mySelect.CommandText = "delete * from t21_Search where t21_FK_t01 = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        REM *---------------------------------------------------------*
        REM *  Datensatz in Historien-Tabelle löschen                 *
        REM *---------------------------------------------------------*
        mySelect.Connection = con
        mySelect.CommandText = "delete * from t88_Historie where t88_FK_t01 = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        REM *---------------------------------------------------------*
        REM *  Datensatz in Aufgaben-Tabelle löschen                  *
        REM *---------------------------------------------------------*
        mySelect.Connection = con
        mySelect.CommandText = "delete * from t99_Aufgabe where t99_FK_t01 = " & p_int_ID.ToString
        Try
            DB_Anz = mySelect.ExecuteNonQuery
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

End Class
