﻿Imports NM_Ahnen.NM_Ahnen
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_02_DB_Person_Read

Public Class Cls_20_Blaettern

    REM ******************************************************************
    REM *  Blättermodus - Anzeige der 1. Datensatzes der Tabelle         *
    REM ******************************************************************
    Public Shared Sub Blaettern_First()

        int_Sel_TabY = int_Sel_TabX * -1
        Call Tab_Reiter_Change()
        int_Zeig_Pers = 0
        dbl_ID = lng_ID(int_Zeig_Pers)
        If int_Akt_ID > 0 Then
            dbl_ID = int_Akt_ID
            NM_Ahnen.tx_00_ID.Text = dbl_ID.ToString
            int_Akt_ID = 0
        End If
        Call Person_Read_01()

    End Sub

    REM ******************************************************************
    REM *  Blättermodus - Anzeige des vorherigen Datensatzes der Tabelle *
    REM ******************************************************************
    Public Shared Sub Blaettern_Before()

        int_Sel_TabY = int_Sel_TabX * -1
        Call Tab_Reiter_Change()
        If int_Zeig_Pers > 0 Then
            int_Zeig_Pers -= 1
        End If
        dbl_ID = lng_ID(int_Zeig_Pers)
        Call Person_Read_01()

    End Sub

    REM ******************************************************************
    REM *  Blättermodus - Anzeige des folgenden Datensatzes der Tabelle  *
    REM ******************************************************************
    Public Shared Sub Blaettern_Next()
        int_Sel_TabY = int_Sel_TabX + -1
        Call Tab_Reiter_Change()
        If int_Zeig_Pers < (dbl_Max - 1) Then
            int_Zeig_Pers += 1
        End If
        dbl_ID = lng_ID(int_Zeig_Pers)
        Call Person_Read_01()

    End Sub

    REM ******************************************************************
    REM *  Blättermodus - Anzeige des letzten Datensatzes der Tabelle    *
    REM ******************************************************************
    Public Shared Sub Blaettern_Last()

        int_Sel_TabY = int_Sel_TabX + -1
        Call Tab_Reiter_Change()
        int_Zeig_Pers = dbl_Max - 1
        dbl_ID = lng_ID(int_Zeig_Pers)
        Call Person_Read_01()

    End Sub

End Class
