﻿Imports System.Data.OleDb
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.Cls_90_Mask_201
Public Class Cls_91_DB_Para_08

    REM ***********************************************************************
    REM *  Bearbeitung Parametertabelle a08 (Todesbegriffe)                   *
    REM ***********************************************************************
    Public Shared Sub Para_Tod_Load()
        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Tod.Rows.Clear()
            For int_i5 = 1 To int_AnzTod
                .dgv_Tod.Rows.Add(int_i5.ToString("0000"), str_Para_Tod_Text(int_i5), int_Para_Tod_Anz(int_i5))
            Next
            .dgv_Tod.Sort(.dgv_Tod.Columns(1), System.ComponentModel.ListSortDirection.Ascending)
        End With
    End Sub
    Public Shared Sub Para_Tod_Neu()
        With NM_Ahnen_Para
            int_AnzTod += 1
            .tx_201_Z1.Text = ""
        End With
    End Sub

    REM ***************************************************************
    REM * Datensatz einfügen                                          *
    REM ***************************************************************
    Public Shared Sub Para_Tod_Insert()
        Dim int_Hanz As Integer = 0
        Call DB_Tab_High("a08_ID", "a08_Tod")
        dbl_Max_ID += 1
        int_AnzTod += 1
        NM_Ahnen_Para.tx_201_Z1.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z1.Text)
        str_DBD_a08 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_a08 += "'" + NM_Ahnen_Para.tx_201_Z1.Text + "',"
        str_DBD_a08 += "'" + int_Hanz.ToString + "')"
        str_Tab = str_DBS_a08 + str_DBD_a08
        mySelect.CommandText = "insert into a08_Tod " & str_Tab
        Call DB_Execute()
        Call Tab_Tod()
        Call Para_Tod_Load()
    End Sub

    REM ***********************************************************
    REM *  Datensatz updaten                                      *
    REM ***********************************************************
    Public Shared Sub Para_Tod_Update()
        Dim reader As OleDbDataReader
        Dim int_a08_Typ As Integer = 1
        Dim int_i88 As Integer
        With NM_Ahnen_Para
            .tx_201_Z1.Text = .dgv_Tod.CurrentRow.Cells(1).Value
            For int_i88 = 0 To int_AnzTod
                If .tx_201_Z1.Text = str_Para_Tod_Text(int_i88) Then
                    dbl_x = int_Para_Tod_Nr(int_i88)
                    Exit For
                End If
            Next
        End With
        mySelect.CommandText = "select * from a08_Tod"
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a08_ID"))
                If myNull = False Then dbl_x = reader.Item("a08_ID")
            Loop
            reader.Close()
        Catch ex As Exception
        End Try
    End Sub

    REM *******************************************************
    REM *  Einfügen in DB                                     *
    REM *******************************************************
    Public Shared Sub Para_Tod_Update2()
        NM_Ahnen_Para.tx_201_Z1.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z1.Text)
        str_Tab = "a08_Text = '" + NM_Ahnen_Para.tx_201_Z1.Text + "'"
        mySelect.CommandText = "update a08_Namen set " & str_Tab & " where a08_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Tod()
        Call Para_Tod_Load()
    End Sub

    REM *********************************************************
    REM *  Gesamtbestand neu aufbauen                           *
    REM *********************************************************
    Public Shared Sub Para_Tod_Aufbau()
        Dim int_Anz As Integer = GetNumberOfRecords(con, "t03_Beerd")
        Dim str_N1 As String
        Dim reader As OleDbDataReader
        ReDim str_Tab_Orte(int_Anz)
        ReDim int_Para_Anzahl(int_Anz)
        int_Anz_Ort = 1
        REM *  alte Werte löschen
        mySelect.CommandText = "delete * from a08_Tod"
        Call DB_Execute()
        mySelect.CommandText = "select * from t03_Beerd"
        reader = mySelect.ExecuteReader
        Do While reader.Read
            str_N1 = ""
            myNull = IsDBNull(reader.Item("t03_Tod_Ursache"))
            If myNull = False Then str_N1 = reader.Item("t03_Tod_Ursache")
            str_N1 = Trim(str_N1)
            If str_N1 > "" Then Call Para_Tod_Tabelle(str_N1)
        Loop
        reader.Close()
        Call Para_Tod_Aufbau_Insert()
    End Sub

    REM *********************************************************
    REM *  Daten in Tabelle sammeln                             *
    REM *********************************************************
    Public Shared Sub Para_Tod_Tabelle(ByVal str_NX As String)
        Dim i88 As Integer
        For i88 = 1 To int_Anz_Ort - 1
            If str_Tab_Orte(i88) = str_NX Then
                int_Para_Anzahl(i88) += 1
                Exit Sub
            End If
        Next
        str_Tab_Orte(int_Anz_Ort) = str_NX
        int_Para_Anzahl(int_Anz_Ort) = 1
        int_Anz_Ort += 1
    End Sub

    REM ***********************************************************
    REM *  Tabelle in DB übertragen                               *
    REM ***********************************************************
    Public Shared Sub Para_Tod_Aufbau_Insert()
        Dim int_i88 As Integer
        Call DB_Tab_High("a08_ID", "a08_Tod")
        For int_i88 = 1 To int_Anz_Ort - 1
            dbl_Max_ID += 1
            str_Tab_Orte(int_i88) = DB_ZeichenString(str_Tab_Orte(int_i88))

            str_DBD_a08 = " values ('" + dbl_Max_ID.ToString + "',"
            str_DBD_a08 += "'" + str_Tab_Orte(int_i88).ToString + "',"
            str_DBD_a08 += "'" + int_Para_Anzahl(int_i88).ToString + "')"
            str_Tab = str_DBS_a08 + str_DBD_a08
            mySelect.CommandText = "insert into a08_Tod " & str_Tab
            Call DB_Execute()
        Next
        Call Tab_Tod()
        Call Para_Tod_Load()
    End Sub

End Class
