﻿Imports System
Imports System.IO
Imports System.Data.OleDb
Imports NM_Ahnen.Cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_02_DB_Person_Read
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_09_Koeln
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_50_Daten_10
Imports NM_Ahnen.cls_50_Daten_11
Imports NM_Ahnen.cls_50_Daten_12
Imports NM_Ahnen.cls_50_Daten_13
Imports NM_Ahnen.cls_50_Daten_14
Imports NM_Ahnen.cls_50_Daten_15
Imports NM_Ahnen.cls_50_Daten_16
Imports NM_Ahnen.cls_50_Daten_17

Public Class Cls_03_DB_Person_Neu
    REM **************************************************************
    REM *  Updaten der Personen-Basisdaten                           *
    REM **************************************************************
    Public Shared Sub Person_Neu_Init()
        REM   Merker normieren
        int_Merk_Neu = 0
        int_Merk_Tab_Anschr = 0
        int_Merk_Tab_Beerd = 0
        int_Merk_Tab_Beruf = 0
        int_Merk_Tab_Ehe = 0
        int_Merk_Tab_Grund = 0
        int_Merk_Tab_Paten = 0
        int_Merk_Tab_Taufe = 0
        int_Merk_Tab_Text = 0
        REM  Zähler für Grids löschen
        int_Pate = -1
        int_Pate1 = -1
        int_Zeuge = -1
        int_Zeuge1 = -1
        int_Zeuge2 = -1
        int_Ges = -1
        int_Ehe = -1
        int_Kind = -1
        REM  Verweise für Eltern auf Null setzen
        p_int_Vater = 0
        p_int_Mutter = 0
        Call Person_Read_Vater()
        Call Person_Read_Mutter()
        REM   Speicherfelder löschen
        If int_Sel_Tab > 0 Then
            int_PicZaehl = p_int_ID
        End If
        Call Mask_Clear()
        If int_Sel_Tab > 0 Then
            p_int_ID = int_PicZaehl
        End If
        int_Sel_Tab = 0
        int_Sel_TabX = 6
        NM_Ahnen.tb1.SelectTab(int_Sel_Tab)
        NM_Ahnen.tb1.Show()

        Call Tab_Reiter_Change()
        Call Change_Info_10(False)
        REM   Masken löschen
        Call Mask_Out_Person()
        REM  Maske Basisdaten steuern
        Call TabPos_Mask10()
        Call Change_Info_10(False)
        REM  Maske Taufe steuern
        If int_Sel_Tab = 1 Then
            Call TabPos_Mask11()
            Call Change_Info_11(False)
        End If
        REM  Maske Beerdigung steuern
        If int_Sel_Tab = 2 Then
            Call TabPos_Mask12()
            Call Change_Info_12(False)
        End If
        REM  Maske Ehe steuern
        If int_Sel_Tab = 3 Then
            Call TabPos_Mask13()
            Call Change_Info_13(False)
        End If
        REM Maske Anschriften steuern
        If int_Sel_Tab = 4 Then
            Call TabPos_Mask14()
            Call Mask14_Clear()
            Call Change_Info_14(False)
        End If
        REM Maske Berufe steuern
        If int_Sel_Tab = 5 Then
            Call TabPos_Mask15()
            Call Mask15_Clear()
            Call Change_Info_15(False)
        End If
        REM  Maske Text steuern
        If int_Sel_Tab = 6 Then
            Call TabPos_Mask16()
            Call Change_Info_16(False)
        End If
        REM Maske Paten steuern
        If int_Sel_Tab = 7 Then
            Call TabPos_Mask17()
            Call Change_Info_17(False)
        End If
        REM   Nächste freie ID ermitteln
        If int_Sel_Tab = 0 Then
            Call DB_Tab_High("t01_ID", "t01_Person")
            dbl_Max_ID += 1
            dbl_Pers_ID = dbl_Max_ID
            p_int_ID = dbl_Max_ID
        End If
        If int_Sel_Tab > 0 Then Call Person_Read_t01_Basis()
        Call Mask_Out_Header()

        REM   OK/Abbruch-Button aktivieren
        Call Change_Button(myJa)
        With NM_Ahnen
            .AcceptButton = .bt_xx_OK
        End With
    End Sub

    Public Shared Sub Person_Neu()
        REM   Daten übernehmen
        If int_Sel_Tab = 0 Then
            Call Plausi_Daten_Tab10()
            Call Plausi_DB_Zeichen_Tab10()
            Call Person_Insert()
        End If
        If int_Sel_Tab = 1 Then
            Call Plausi_Daten_Tab11()
            Call Plausi_DB_Zeichen_Tab11()
            Call Person_Taufe_Insert()
        End If
        If int_Sel_Tab = 2 Then
            Call Plausi_Daten_Tab12()
            Call Plausi_DB_Zeichen_Tab12()
            Call Person_Beerd_Insert()
        End If
        If int_Sel_Tab = 3 Then
            Call Plausi_Daten_Tab13()
            Call Plausi_DB_Zeichen_Tab13()
            Call Person_Ehe_041()
        End If
        If int_Sel_Tab = 4 Then
            Call Plausi_Daten_Tab14()
            Call Plausi_DB_Zeichen_Tab14()
            Call Person_Adresse_Insert()
        End If
        If int_Sel_Tab = 5 Then
            Call Plausi_Daten_Tab15()
            Call Plausi_DB_Zeichen_Tab15()
            Call Person_Beruf_Insert()
            Call Person_Read_Beruf()
            Call Mask_Out_15()
        End If
        If int_Sel_Tab = 6 Then
            Call Plausi_Daten_Tab16()
            Call Plausi_DB_Zeichen_Tab16()
            Call Person_Text_Insert()
        End If

        Call Change_Button(myNein)
        With NM_Ahnen
            '.bt_00_Neu.Visible = False
        End With
        Call Person_Read_01()

    End Sub

    REM **************************************************************
    REM *  Neuanlage einer Person = Tabelle t01                      *
    REM **************************************************************
    Public Shared Sub Person_Insert()
        With NM_Ahnen
            str_DBD_t01 = " values (" + p_int_ID.ToString + ", "      ' Personen_ID
            str_DBD_t01 += "'" + .tx_10_Name.Text + "', "             ' Name
            str_DBD_t01 += "'" + .tx_10_GebName.Text + "', "          ' Geburtsname
            str_DBD_t01 += "'" + .tx_10_NameZ.Text + "', "            ' Namenszusatz
            str_DBD_t01 += "'" + .tx_10_Vorname.Text + "', "          ' Vorname
            str_DBD_t01 += "'" + .tx_10_Rufname.Text + "', "          ' Rufname
            str_DBD_t01 += "'" + .tx_10_SpitzN.Text + "', "           ' Spitzname
            str_DBD_t01 += "'" + .tx_10_Titel.Text + "', "            ' Titel
            str_DBD_t01 += "'" + .tx_10_Geschl.Text + "', "           ' Geschlecht
            str_DBD_t01 += Val(.tx_10_Vater.Text).ToString + ", "     ' Vater
            str_DBD_t01 += Val(.tx_10_Mutter.Text).ToString + ", "    ' Mutter
            dbl_Vater = Val(.tx_10_Vater.Text)
            dbl_Mutter = Val(.tx_10_Mutter.Text)
            str_DBD_t01 += "'" + .tx_10_GDat_TT.Text + "', "          ' Geburtsdatum (Tag)
            str_DBD_t01 += "'" + .tx_10_GDat_MM.Text + "', "          ' Geburtsdatum (Monat)
            str_DBD_t01 += "'" + .tx_10_GDat_JJ.Text + "', "          ' Geburtsdatum (Jahr)
            str_DBD_t01 += "'" + .tx_10_GDat_TT.Text + "." + .tx_10_GDat_MM.Text + "." + .tx_10_GDat_JJ.Text + "',"
            str_DBD_t01 += "'" + .tx_10_GDat_JJ.Text + .tx_10_GDat_MM.Text + .tx_10_GDat_TT.Text + "', "
            str_DBD_t01 += "'" + int_GDat_Art.ToString + "', "        ' GebDatum-Art
            str_DBD_t01 += "'" + .tx_10_GOrt.Text + "', "             ' GebOrt
            str_DBD_t01 += "'" + " " + "', "                          ' Geb-Urkunde
            str_DBD_t01 += "'" + " " + "', "                          ' Geb-Urkunde2
            str_DBD_t01 += "'" + .tx_10_SDat_TT.Text + "', "          ' Sterbedatum (Tag)
            str_DBD_t01 += "'" + .tx_10_SDat_MM.Text + "', "          ' Sterbedatum (Monat)
            str_DBD_t01 += "'" + .tx_10_SDat_JJ.Text + "', "          ' Sterbedatum (Jahr)
            str_DBD_t01 += "'" + .tx_10_SDat_TT.Text + "." + .tx_10_SDat_MM.Text + "." + .tx_10_SDat_JJ.Text + "', "
            str_DBD_t01 += "'" + .tx_10_SDat_JJ.Text + .tx_10_SDat_MM.Text + .tx_10_SDat_TT.Text + "', "
            str_DBD_t01 += "'" + int_SDat_Art.ToString + "', "        ' Sterbedatum-Art
            str_DBD_t01 += "'" + " " + "', "                          ' Sterbeort
            str_DBD_t01 += "'" + " " + "', "                          ' Sterbeurkunde
            str_DBD_t01 += "'" + " " + "', "                          ' Sterbeurkunde 2

            REM * Achtung, noch Searchbegriffe bilden
            str_SearchX = ""
            If .tx_10_Name.Text <> "" Then str_SearchX = KoelnKonvert(.tx_10_Name.Text)
            str_DBD_t01 += "'" + str_SearchX + "', "                  ' Search-Name
            str_SearchX = ""
            If .tx_10_GebName.Text <> "" Then str_SearchX = KoelnKonvert(.tx_10_GebName.Text)
            str_DBD_t01 += "'" + str_SearchX + "', "                  ' Search-GebName
            str_SearchX = ""
            If .tx_10_SpitzN.Text <> "" Then str_SearchX = KoelnKonvert(.tx_10_SpitzN.Text)
            str_DBD_t01 += "'" + str_SearchX + "', "                  ' Search-SpitzName
            str_SearchX = ""
            If .tx_10_NameZ.Text <> "" Then str_SearchX = KoelnKonvert(.tx_10_NameZ.Text)
            str_DBD_t01 += "'" + str_SearchX + "', "                  ' Search-Namenszusatz
            str_DBD_t01 += "'" + str_AktDat + "', "                   ' NeuDat
            str_DBD_t01 += "'')"                                      ' AendDat
        End With

        dbl_ID = p_int_ID
        int_Merk_Tab_Grund = 1

        mySelect.CommandText = "insert into t01_Person " & str_DBS_t01 & str_DBD_t01
        Call DB_Execute()
        Call Person_Eltern_Neu()
        Call Person_KommNr_Insert()
        If int_Merk_Import = 0 Then Call ID_Tab_Fuell()

    End Sub

    REM **************************************************************
    REM *  Einfügen der Taufdaten = Tabelle t02                      *
    REM **************************************************************
    Public Shared Sub Person_Taufe_Insert()
        With NM_Ahnen
            str_DBD_t02 = " values (" + p_int_ID.ToString + ", "            ' Personen_ID
            str_DBD_t02 += "'" + .cbx_11_Konf.Text + "', "                  ' Konfession
            str_DBD_t02 += "'" + .tx_11_TDat_TT.Text + "', "                ' Taufdatum Tag
            str_DBD_t02 += "'" + .tx_11_TDat_MM.Text + "', "                ' Taufdatum Monat
            str_DBD_t02 += "'" + .tx_11_TDat_JJ.Text + "', "                ' Taufdatum Jahr
            str_Dat_H = .tx_11_TDat_TT.Text + "." + .tx_11_TDat_MM.Text + "." + .tx_11_TDat_JJ.Text
            str_DBD_t02 += "'" + str_Dat_H + "', "                            ' Taufdatum 
            str_DBD_t02 += "'" + int_TDat_Art.ToString + "', "              ' Taufdatum Art
            str_DBD_t02 += "'" + .tx_11_Tauf_Ort.Text + "', "               ' Taufort
            str_DBD_t02 += "'" + .tx_11_Tauf_Kirche.Text + "', "            ' Taufkirche
            str_DBD_t02 += "'" + .tx_11_Priester.Text + "', "               ' Taufpriester
            str_DBD_t02 += "'" + " " + "', "               ' Taufurkunde
            str_DBD_t02 += "'" + .tx_11_FDat_TT.Text + "', "                ' Firmdatum Tag
            str_DBD_t02 += "'" + .tx_11_FDat_MM.Text + "', "                ' Firmdatum Monat
            str_DBD_t02 += "'" + .tx_11_FDat_JJ.Text + "', "                ' Firmdatum Jahr
            str_Dat_H = .tx_11_FDat_TT.Text + "." + .tx_11_FDat_MM.Text + "." + .tx_11_FDat_JJ.Text
            str_DBD_t02 += "'" + str_Dat_H + "', "                            ' Firmdatum 
            str_DBD_t02 += "'" + int_FDat_Art.ToString + "', "              ' Taufdatum Art
            str_DBD_t02 += "'" + .tx_11_FOrt.Text + "', "                   ' Firmort
            str_DBD_t02 += "'" + .tx_11_FKirche.Text + "', "                ' Firmkirche
            str_DBD_t02 += "'" + .tx_11_FPriester.Text + "', "              ' Firmpriester
            str_DBD_t02 += "'" + " " + "', "               ' Firmurkunde
            str_DBD_t02 += "'" + .rtx_11_Bemerk.Text + "')"                 ' Bemerkung
        End With
        mySelect.CommandText = "insert into t02_Taufe " & str_DBS_t02 & str_DBD_t02
        Call DB_Execute()
        int_Merk_Tab_Taufe = 1
        REM **  Achtung Kommentarsatz noch erstellen

    End Sub

    REM **************************************************************
    REM *  Einfügen der KommentardatenNr = Tabelle t10               *
    REM **************************************************************
    Public Shared Sub Person_KommNr_Insert()
        Dim str_Null As String = "0"
        str_DBD_t10 = " values (" + p_int_ID.ToString + ", "            ' Personen_ID
        For i1 = 1 To 65
            str_DBD_t10 += "'" + str_Null + "', "                       ' Kommentarfeld 65 mal
        Next
        str_DBD_t10 += "'0')"
        mySelect.CommandText = "insert into t10_KommNr " & str_DBS_t10 & str_DBD_t10
        Call DB_Execute()
    End Sub

    REM **************************************************************
    REM *  Einfügen der Beerdigungsdaten = Tabelle t03               *
    REM **************************************************************
    Public Shared Sub Person_Beerd_Insert()
        With NM_Ahnen
            str_DBD_t03 = " values (" + p_int_ID.ToString + ", "            ' Personen_ID
            str_DBD_t03 += "'" + .tx_12_BDat_TT.Text + "', "                ' Beerd.datum Tag
            str_DBD_t03 += "'" + .tx_12_BDat_MM.Text + "', "                ' Beerd.datum Monat
            str_DBD_t03 += "'" + .tx_12_BDat_JJ.Text + "', "                ' Beerddatum Jahr
            str_Dat_H = .tx_11_TDat_TT.Text + "." + .tx_11_TDat_MM.Text + "." + .tx_11_TDat_JJ.Text
            str_DBD_t03 += "'" + str_Dat_H + "', "                            ' Beerd.datum 
            str_DBD_t03 += "'" + int_BDat_Art.ToString + "', "              ' Beerd.datum Art
            str_DBD_t03 += "'" + .tx_12_B_Ort.Text + "', "                  ' Beerd.Ort
            str_DBD_t03 += "'" + .tx_12_B_Art.Text + "', "                  ' Beerd.Art
            str_DBD_t03 += "'" + .tx_12_Priester.Text + "', "               ' Beerd.priester
            str_DBD_t03 += "'" + .tx_12_Friedhof.Text + "', "               ' Friedhof
            str_DBD_t03 += "'" + .tx_12_Grablage.Text + "', "               ' Grablage
            str_DBD_t03 += "'" + .tx_12_Tod_Ursache.Text + "', "            ' Todesursache
            str_DBD_t03 += "'" + " " + "', "                                ' Sterbeurkunde1
            str_DBD_t03 += "'" + "  " + " ', "                              ' Sterbeurkunde2
            str_DBD_t03 += "'" + .rtx_12_Bemerk.Text + "')"                 ' Bemerkung
        End With
        mySelect.CommandText = "insert into t03_Beerd " & str_DBS_t03 & str_DBD_t03
        Call DB_Execute()
        int_Merk_Tab_Beerd = 1
    End Sub

    REM **************************************************************
    REM *  Zusammenbau des Insertdatenstrings t04_Ehe                *
    REM **************************************************************
    Public Shared Sub Person_Ehe_04()
        REM * -------------------------------------------------------*
        REM * *  Verweisdaten für Partner 1 anlegen                  *
        REM *--------------------------------------------------------*
        Call DB_Tab_High("t04_ID", "t04_Ehe")
        dbl_Max_ID += 1
        str_DBD_t04 = "values ('"
        str_DBD_t04 += dbl_Max_ID.ToString + "', '"
        str_DBD_t04 += dbl_ID.ToString + "', '"
        str_DBD_t04 += dbl_Sel_ID.ToString + "', '"
        str_DBD_t04 += dbl_T41_ID.ToString + "')"
        mySelect.CommandText = "insert into t04_Ehe " + str_DBS_t04 + str_DBD_t04
        Call DB_Execute()
        REM * -------------------------------------------------------*
        REM * *  Verweisdaten für Partner 2 anlegen                  *
        REM *--------------------------------------------------------*
        dbl_Max_ID += 1
        str_DBD_t04 = "values ('"
        str_DBD_t04 += dbl_Max_ID.ToString + "', '"
        str_DBD_t04 += dbl_Sel_ID.ToString + "', '"
        str_DBD_t04 += dbl_ID.ToString + "', '"
        str_DBD_t04 += dbl_T41_ID.ToString + "')"

        mySelect.CommandText = "insert into t04_Ehe " + str_DBS_t04 + str_DBD_t04
        Call DB_Execute()

    End Sub

    REM **************************************************************
    REM *  Zusammenbau des Insertdatenstrings t041_Ehe               *
    REM **************************************************************
    Public Shared Sub Person_Ehe_041()
        Call DB_Tab_High("t041_ID", "t041_EheDaten")
        dbl_Max_ID += 1
        dbl_T41_ID = dbl_Max_ID

        With NM_Ahnen
            str_DBD_t041 = " values (" + dbl_Max_ID.ToString + ", "
            str_DBD_t041 += "'" + .tx_13_Dat1_TT.Text + "', "           ' Ehedatum Tag
            str_DBD_t041 += "'" + .tx_13_Dat1_MM.Text + "', "           ' Ehedatum Monat
            str_DBD_t041 += "'" + .tx_13_Dat1_JJ.Text + "', "           ' Ehedatum Jahr
            str_Dat_H = .tx_13_Dat1_TT.Text + "." + .tx_13_Dat1_MM.Text + "." + .tx_13_Dat1_JJ.Text
            str_DBD_t041 += "'" + str_Dat_H + "', "                     ' Ehedatum 
            str_DBD_t041 += int_EDat1_Art.ToString + ", "
            str_DBD_t041 += "'" + .tx_13_Ort1.Text + "', "
            str_DBD_t041 += "'" + .tx_13_Beamter.Text + "', "
            str_DBD_t041 += "'" + " " + "', "
            str_DBD_t041 += "'" + .tx_13_Dat2_TT.Text + "', "            ' Ehedatum Tag
            str_DBD_t041 += "'" + .tx_13_Dat2_MM.Text + "', "            ' Ehedatum Monat
            str_DBD_t041 += "'" + .tx_13_Dat2_JJ.Text + "', "            ' Ehedatum Jahr
            str_Dat_H = .tx_13_Dat2_TT.Text + "." + .tx_13_Dat2_MM.Text + "." + .tx_13_Dat2_JJ.Text
            str_DBD_t041 += "'" + str_Dat_H + "', "                      ' Ehedatum 
            str_DBD_t041 += int_EDat2_Art.ToString + ", "
            str_DBD_t041 += "'" + .tx_13_Ort2.Text + "', "
            str_DBD_t041 += "'" + .tx_13_Kirche.Text + "', "
            str_DBD_t041 += "'" + .tx_13_Priester.Text + "', "
            str_DBD_t041 += "'" + " " + "', "

            str_DBD_t041 += "'" + .tx_13_Dat3_TT.Text + "', "            ' Ehedatum Tag
            str_DBD_t041 += "'" + .tx_13_Dat3_MM.Text + "', "            ' Ehedatum Monat
            str_DBD_t041 += "'" + .tx_13_Dat3_JJ.Text + "', "            ' Ehedatum Jahr
            str_Dat_H = .tx_13_Dat3_TT.Text + "." + .tx_13_Dat3_MM.Text + "." + .tx_13_Dat3_JJ.Text
            str_DBD_t041 += "'" + str_Dat_H + "', "                      ' Ehedatum 
            str_DBD_t041 += int_EDat3_Art.ToString + ", "
            str_DBD_t041 += "'" + " " + "', "
            str_DBD_t041 += "'" + .rtx_13_Bemerk.Text + "')"                 ' Bemerkung
        End With
        mySelect.CommandText = "insert into t041_EheDaten " + str_DBS_t041 + str_DBD_t041
        Call DB_Execute()
        Call Person_Ehe_04()
        int_Merk_Tab_Ehe = 1
    End Sub
    Public Shared Sub Person_Eltern_Neu()

        If dbl_Vater > "0" Then
            REM *   Vaterdaten
            Call DB_Tab_High("t05_ID", "t05_Rolle")
            dbl_Max_ID += 1

            str_DBD_t05 = " Values (" + dbl_Max_ID.ToString + ", "
            str_DBD_t05 += "'" + dbl_Vater.ToString + "', "
            str_DBD_t05 += "'3',"
            str_DBD_t05 += "'" + p_int_ID.ToString + "')"

            mySelect.CommandText = "insert into t05_Rolle " & str_DBS_t05 + str_DBD_t05
            Call DB_Execute()
        End If

        If dbl_Mutter > "0" Then
            REM *  Mutterdaten
            Call DB_Tab_High("t05_ID", "t05_Rolle")
            dbl_Max_ID += 1

            str_DBD_t05 = " Values (" + dbl_Max_ID.ToString + ", "
            str_DBD_t05 += "'" + dbl_Mutter.ToString + "', "
            str_DBD_t05 += "'3',"
            str_DBD_t05 += "'" + p_int_ID.ToString + "')"

            mySelect.CommandText = "insert into t05_Rolle " & str_DBS_t05 + str_DBD_t05
            Call DB_Execute()
        End If

    End Sub
    REM **************************************************************
    REM *  Einfügen der Adressdaten = Tabelle t06                    *
    REM **************************************************************
    Public Shared Sub Person_Adresse_Insert()

        REM * ermitteln lfd-Nr High
        Dim reader As OleDbDataReader
        int_Anz_Adr = 0
        Dim int_i5 As Integer = 0

        mySelect.Connection = con
        mySelect.CommandText = "select * from t06_Adr where t06_FK_t01 = " + p_int_ID.ToString

        reader = mySelect.ExecuteReader
        If reader.HasRows Then
            Do While reader.Read()
                myNull = IsDBNull(reader.Item("t06_Lfd"))
                If myNull = False Then int_i5 = reader.Item("t06_Lfd")
                If int_i5 > int_Anz_Adr Then int_Anz_Adr = int_i5
            Loop
            int_Anz_Adr += 1
        End If
        reader.Close()

        REM * Höchste ID für Tabelle ermitteln
        Call DB_Tab_High("t06_ID", "t06_Adr")
        dbl_Max_ID += 1

        ' str_DBS_t06  = Strukturbezeichnung
        ' str_DBD_t06  = Daten

        With NM_Ahnen
            str_DBD_t06 = "values ('"
            str_DBD_t06 += dbl_Max_ID.ToString + "', "                  ' Datensatz_ID
            str_DBD_t06 += "'" + p_int_ID.ToString + "', "              ' ID_Verweis t01
            str_DBD_t06 += "'" + int_Anz_Adr.ToString + "', "           ' Lfd-Nr für Person
            str_DBD_t06 += "'" + .tx_14_Land.Text + "', "               ' Land
            str_DBD_t06 += "'" + .tx_14_PLZ.Text + "', "                ' PLZ
            str_DBD_t06 += "'" + .tx_14_Ort.Text + "', "                ' PLZ
            str_DBD_t06 += "'" + .tx_14_Strasse.Text + "', "            ' Strasse
            str_Dat_H = .tx_14_Dat1_TT.Text + "." + .tx_14_Dat1_MM.Text + "." + .tx_14_Dat1_JJ.Text
            str_DBD_t06 += "'" + str_Dat_H + "', "                        ' Datum von 
            str_Dat_H = .tx_14_Dat2_TT.Text + "." + .tx_14_Dat2_MM.Text + "." + .tx_14_Dat2_JJ.Text
            str_DBD_t06 += "'" + str_Dat_H + "', "                        ' Datum bis 
            str_DBD_t06 += "'" + "0" + "', "                            ' Telefon 1
            str_DBD_t06 += "'" + "0" + "', "                            ' Telefon 2
            str_DBD_t06 += "'" + "0" + "', "                            ' Telefax
            str_DBD_t06 += "'" + "0" + "', "                            ' Mail
            str_DBD_t06 += "'0', "                                      ' Homepage
            str_DBD_t06 += "'" + .rtx_12_Bemerk.Text + "')"             ' Bemerkung
        End With

        mySelect.CommandText = "insert into t06_Adr " + str_DBS_t06 + str_DBD_t06
        Call DB_Execute()

        'Person_Read_Adresse()
        'Call Mask_Out_14()

    End Sub

    REM **************************************************************
    REM *  Einfügen der Berufsdaten = Tabelle t07                    *
    REM **************************************************************
    Public Shared Sub Person_Beruf_Insert()

        REM * ermitteln lfd-Nr High
        Dim reader As OleDbDataReader
        int_Anz_Adr = 0
        Dim int_i5 As Integer = 0

        Call Find_Beruf()

        mySelect.Connection = con
        str_Where = " where t07_FK_t01 = " + p_int_ID.ToString
        int_Anz_Adr = GetNumberOfRecordsTyp(con, "t07_Beruf", str_Where)

        mySelect.Connection = con
        mySelect.CommandText = "select * from t07_Beruf where t07_FK_t01 = " + p_int_ID.ToString

        reader = mySelect.ExecuteReader
        If reader.HasRows Then
            Do While reader.Read()
                myNull = IsDBNull(reader.Item("t07_Lfd"))
                If myNull = False Then int_i5 = reader.Item("t07_Lfd")
                If int_i5 > int_Anz_Adr Then int_Anz_Adr = int_i5
            Loop
            int_Anz_Adr += 1
        Else
            int_Anz_Adr = 1
        End If
        reader.Close()

        REM * Höchste ID für Tabelle ermitteln
        Call DB_Tab_High("t07_ID", "t07_Beruf")
        dbl_Max_ID += 1

        ' str_DBS_t07  = Strukturbezeichnung
        ' str_DBD_t07  = Daten

        With NM_Ahnen
            str_DBD_t07 = "values ('"
            str_DBD_t07 += dbl_Max_ID.ToString + "', "                  ' Datensatz_ID
            str_DBD_t07 += "'" + p_int_ID.ToString + "', "              ' ID_Verweis t01
            str_DBD_t07 += "'" + int_Anz_Adr.ToString + "', "           ' Lfd-Nr für Person

            REM VerweisNr für tabelle t77
            str_DBD_t07 += "'" + int_BerufN.ToString + "', "
            str_Dat_H = .tx_15_Dat1_TT.Text + "." + .tx_15_Dat1_MM.Text + "." + .tx_15_Dat1_JJ.Text
            str_DBD_t07 += "'" + str_Dat_H + "', "                        ' Datum von 
            str_Dat_H = .tx_15_Dat2_TT.Text + "." + .tx_15_Dat2_MM.Text + "." + .tx_15_Dat2_JJ.Text
            str_DBD_t07 += "'" + str_Dat_H + "', "                        ' Datum bis 
            str_DBD_t07 += "'" + .rtx_12_Bemerk.Text + "')"               ' Bemerkung
        End With

        mySelect.CommandText = "insert into t07_Beruf " + str_DBS_t07 + str_DBD_t07
        Call DB_Execute()

        'Person_Read_Beruf()
        'Call Mask_Out_15()

    End Sub

    REM **************************************************************
    REM *  Suchen der Berufseingabe in Berufstabelle                 *
    REM **************************************************************
    Public Shared Sub Find_Beruf()

        Dim int_k77 As Integer
        Dim str_Msgx As String = "Beruf neu anlegen"
        Dim str_Msg As String = "Soll der Beruf neu angelegt werden?"
        int_BerufN = -1
        For int_k77 = 0 To dbl_Beruf_Max
            With NM_Ahnen
                If tab_Beruf_Bez(int_k77) = .tx_15_Beruf.Text Then
                    int_BerufN = tab_Beruf_ID(int_k77)
                    Exit Sub
                End If
            End With
        Next
        If int_Merk_Import = 0 Then
            If int_BerufN < 0 Then
                Dim result As DialogResult = MessageBox.Show(str_Msg, str_Msgx, MessageBoxButtons.OKCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)
            End If
            If MsgBoxResult.Yes Then
                Call Beruf_Insert()
            End If
        Else
            Call Beruf_Insert()
        End If

    End Sub

    REM ****************************************************************
    REM *  Berufstabelle ergänzen                                      *
    REM ****************************************************************
    Public Shared Sub Beruf_Insert()

        Call DB_Tab_High("t77_ID", "t77_Beruf")
        dbl_Max_ID += 1

        With NM_Ahnen
            str_DBD_t77 = " values (" + dbl_Max_ID.ToString + ", "        ' ID
            str_DBD_t77 += "'" + .tx_15_Beruf.Text + "')"                 ' Berufsbezeichnung
        End With
        int_BerufN = dbl_Max_ID

        mySelect.CommandText = "insert into t77_Beruf " & str_DBS_t77 & str_DBD_t77
        Call DB_Execute()
        If int_Merk_Import = 0 Then Call ID_TabBeruf_Fuell()

    End Sub

    REM **************************************************************
    REM *  Einfügen der Textdaten = Tabelle t12                      *
    REM **************************************************************
    Public Shared Sub Person_Text_Insert()

        With NM_Ahnen
            str_DBD_t12 = " values (" + p_int_ID.ToString + ", "            ' Personen_ID
            str_DBD_t12 += "'" + .rtx_16_1.Text + "')"                      ' Bemerkung

        End With

        mySelect.CommandText = "insert into t12_Text " & str_DBS_t12 & str_DBD_t12
        Call DB_Execute()

    End Sub

End Class
