﻿Imports System.Data.OleDb
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.Cls_90_Mask_201
Public Class Cls_91_DB_Para

    REM ***********************************************************
    REM *  Ändern und Neuanlage Parametersatz                     *
    REM *  int_N: 1 = Datum, int_N=2 = Konfession                 *
    REM *  Int_Para_DB: 1 = Neuanlage, 2 = Ändern                 *
    REM ***********************************************************
    Public Shared Sub Para_Neu(ByVal int_N As Integer)
        With NM_Ahnen_Para
            .lbl_201_Z1.Visible = True
            .tx_201_Z1.Visible = True
            .lbl_201_Z2.Visible = False
            .tx_201_Z2.Visible = False
            .lbl_201_Z3.Visible = False
            .tx_201_Z3.Visible = False
            .bt_201_OK.Visible = True
            If int_Para_DB = 1 Then
                If int_N = 1 Then int_High_Para = int_High_Datum + 1
                If int_N = 2 Then int_High_Para = int_High_Konf + 1
                .lbl_201_Lfdnr1.Text = int_High_Para.ToString
            End If
            If int_N = 1 Then
                .lbl_201_Z1.Text = "Bezeichnung"
            End If
            If int_N = 2 Then
                .lbl_201_Z1.Text = "Kürzel"
                .lbl_201_Z2.Text = "Bezeichnung"
            End If
            .grp_Ort_Neu.Visible = True
            .tb_Para.Show()
        End With

    End Sub


    REM ***********************************************************
    REM *  Ändern und Neuanlage von Datumsarten                   *
    REM ***********************************************************
    Public Shared Sub Para_Datum_Update()
        With NM_Ahnen_Para
            .tx_201_Z1.Text = .dgv_Datum.CurrentRow.Cells(1).Value
            int_SubTyp = .dgv_Datum.CurrentRow.Cells(0).Value
        End With
    End Sub

    Public Shared Sub Para_Datum_DB_Insert()
        int_Para_Typ = 5
        int_SubTyp = int_High_Para
        Call Para00_Insert()
        Call Tab_Datumsart()
        Call Para_Datum_Load()
    End Sub

    Public Shared Sub Para_Datum_DB_Update()
        str_t1 = NM_Ahnen_Para.tx_201_Z1.Text
        Call Para00_Update(4)
        Call Tab_Datumsart()
        Call Para_Datum_Load()
    End Sub

    REM ****************************************************************
    REM *  Ändern und Neuanlage von Konfessionen                       *
    REM ****************************************************************
    Public Shared Sub Para_Konf_Update()
        With NM_Ahnen_Para
            int_SubTyp = .dgv_Datum.CurrentRow.Cells(0).Value
            str_t1 = .dgv_Konf.CurrentRow.Cells(2).Value
            str_t2 = .dgv_Konf.CurrentRow.Cells(3).Value
            int_Para_Feld = 4 : Call Para00_Update(int_Para_Feld)
            int_Para_Feld = 5 : Call Para00_Update(int_Para_Feld)
        End With
    End Sub

    Public Shared Sub Para_Konf_DB_Insert()
        int_Para_Typ = 3
        Call Para00_Insert()
        Call Tab_Konfessionen()
        Call Para_Konf_Load()
    End Sub

    Public Shared Sub Para_Konf_DB_Update()
        str_t1 = NM_Ahnen_Para.tx_201_Z1.Text
        str_t2 = NM_Ahnen_Para.tx_201_Z2.Text
        Call Para00_Update(4)
        Call Tab_Datumsart()
        Call Para_Datum_Load()
    End Sub
    REM **************************************************************
    REM *  Ändern von Altersgrenzen                                  *
    REM **************************************************************
    Public Shared Sub Para_Altersgrenze_DB_Update()
        With NM_Ahnen_Para
            dbl_x = 9
            str_Tab = ""
            str_Tab += "a00_int1 = '" + Val(.tx_202_Vater_Min.Text).ToString + "', "
            str_Tab += "a00_int2 = '" + Val(.tx_202_Vater_Max.Text).ToString + "', "
            mySelect.CommandText = "update a00_Para set " & str_Tab & " where a00_ID = " & dbl_x.ToString
            Call DB_Execute()
            dbl_x = 10
            str_Tab = ""
            str_Tab += "a00_int1 = '" + Val(.tx_202_Mutter_Min.Text).ToString + "', "
            str_Tab += "a00_int2 = '" + Val(.tx_202_Mutter_Max.Text).ToString + "', "
            mySelect.CommandText = "update a00_Para set " & str_Tab & " where a00_ID = " & dbl_x.ToString
            Call DB_Execute()
            dbl_x = 11
            str_Tab = ""
            str_Tab += "a00_int1 = '" + Val(.tx_202_Ehe_Min.Text).ToString + "', "
            str_Tab += "a00_int2 = '" + Val(.tx_202_Ehe_Max.Text).ToString + "', "
            mySelect.CommandText = "update a00_Para set " & str_Tab & " where a00_ID = " & dbl_x.ToString
            Call DB_Execute()
            dbl_x = 12
            str_Tab = ""
            str_Tab += "a00_int1 = '" + Val(.tx_202_Pate_Min.Text).ToString + "', "
            str_Tab += "a00_int2 = '" + Val(.tx_202_Pate_Max.Text).ToString + "', "
            mySelect.CommandText = "update a00_Para set " & str_Tab & " where a00_ID = " & dbl_x.ToString
            Call DB_Execute()
            dbl_x = 13
            str_Tab = ""
            str_Tab += "a00_int1 = '" + Val(.tx_202_Zeuge_Min.Text).ToString + "', "
            str_Tab += "a00_int2 = '" + Val(.tx_202_Zeuge_Max.Text).ToString + "', "
            mySelect.CommandText = "update a00_Para set " & str_Tab & " where a00_ID = " & dbl_x.ToString
            Call DB_Execute()
        End With
    End Sub

    Public Shared Sub Para00_Insert()
        Call DB_Tab_High("a00_ID", "a00_Para")
        dbl_Max_ID += 1
        REM *--------------------------------------------------------*
        REM *  Satz in Tabelle a00 anlegen                           *
        REM *--------------------------------------------------------*
        str_DBD_a00 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_a00 += "'" + int_Para_Typ.ToString + "',"
        str_DBD_a00 += "'" + int_SubTyp.ToString + "',"
        str_DBD_a00 += "'" + int_P1.ToString + "',"
        str_DBD_a00 += "'" + int_P2.ToString + "',"
        str_DBD_a00 += "'" + int_P3.ToString + "',"
        str_DBD_a00 += "'" + str_t1 + "',"
        str_DBD_a00 += "'" + str_t2 + "',"
        str_DBD_a00 += "'" + str_t3 + "')"
        str_Tab = str_DBS_a00 + str_DBD_a00
        mySelect.CommandText = "insert into a00_Para " & str_Tab
        Call DB_Execute()
    End Sub

    REM ***********************************************************
    REM *  Definition der Datumsarten                             *
    REM *  Laden in DataGrid                                      *
    REM ***********************************************************
    Public Shared Sub Para_Datum_Load()
        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Datum.Rows.Clear()
            For int_i5 = 1 To int_AnzPara
                .dgv_Datum.Rows.Add(int_Para_DA(int_i5), int_i5.ToString, str_Para_DA(int_i5))
            Next
        End With
    End Sub


    REM ****************************************************************
    REM *  Parameterdaten Altersgrenzen für Plausi                     *
    REM ****************************************************************
    Public Shared Sub Para_Altersgrenzen_Load()
        With NM_Ahnen_Para
            .tx_202_Vater_Min.Text = int_Delta_Vater_Min.ToString
            .tx_202_Vater_Max.Text = int_Delta_Vater_Max.ToString
            .tx_202_Mutter_Min.Text = int_Delta_Mutter_Min.ToString
            .tx_202_Mutter_Max.Text = int_Delta_Mutter_Max.ToString
            .tx_202_Ehe_Min.Text = int_Delta_Ehe_Min.ToString
            .tx_202_Ehe_Max.Text = int_Delta_Ehe_Max.ToString
            .tx_202_Pate_Min.Text = int_Delta_Pate_Min.ToString
            .tx_202_Pate_Max.Text = int_Delta_Pate_Max.ToString
            .tx_202_Zeuge_Min.Text = int_Delta_Zeuge_Min.ToString
            .tx_202_Zeuge_Max.Text = int_Delta_Zeuge_Max.ToString
        End With
    End Sub

    REM ******************************************************************
    REM *  Parameterdaten für Konfessionsbezeichnungen                   *
    REM ******************************************************************
    Public Shared Sub Para_Konf_Load()
        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Konf.Rows.Clear()
            For int_i5 = 1 To int_AnzKonf
                .dgv_Konf.Rows.Add(int_Para_Konf(int_i5), int_i5.ToString, str_Para_Konf_Bez(int_i5), str_Para_Konf_Text(int_i5))
            Next
        End With
    End Sub

    REM **************************************************************
    REM *  Einfügen von neuen Pfadangaben                            *
    REM **************************************************************
    Public Shared Sub Para_Pfad_DB_Update()
        int_ID = 8
        str_t1 = NM_Ahnen_Para.tx_DokPfad.Text
        Call Para00_Update(4)
    End Sub

End Class
